// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "qlook.h"

#include "HMMLook.h"
#include "qlookDoc.h"

#include "ScrlVwX.h"
#include "MemPaint.h"
#include "qlookView.h"

#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_PHONE, OnSelChangePhone)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	m_pQlView = 0;
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	if (!m_wndDlgBar.Create(this, IDR_MAINFRAME, 
		CBRS_ALIGN_TOP, AFX_IDW_DIALOGBAR))
	{
		TRACE0("Failed to create dialogbar\n");
		return -1;		// fail to create
	}

	if (!m_wndReBar.Create(this) ||
		!m_wndReBar.AddBar(&m_wndToolBar) ||
		!m_wndReBar.AddBar(&m_wndDlgBar))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

void CMainFrame::FillPhoneList(CView* pQlView)
{
	if(m_pQlView == pQlView){return;}
	CComboBox* pCBox = (CComboBox*)m_wndDlgBar.GetDlgItem(IDC_PHONE);
	int nIndex = pCBox->GetCurSel();
	pCBox->ResetContent();
	m_pQlView = pQlView;
	if(!pQlView){return;}
	CDocument* pDoc = m_pQlView->GetDocument(); //GetActiveDocument();
	if(!pDoc || ! pDoc->IsKindOf(RUNTIME_CLASS(CQlookDoc)) ){
		return;
	}
	CQlookDoc* pQlDoc = (CQlookDoc*)pDoc;
	CHMMLook* pHmmLook = pQlDoc->GetHMMLook();
	CHMMModelSet* pHmmSet = pHmmLook->GetHMMSet();
//	CHMMModel& model = pHmmSet->m_Models[m_nCurModel];
	int nModel;
	CString s;
	CHMMModel* pCurHmm;
	int nCurModel = ((CQlookView*)m_pQlView)->GetCurModel();
	int nCurIndex = -1;
	for(nModel=0; nModel<pHmmSet->m_Models.GetSize(); nModel++){
		pCurHmm = &pHmmSet->m_Models[nModel];
		s = pCurHmm->GetName();
		nIndex = pCBox->AddString(s);
		pCBox->SetItemData(nIndex, nModel);
//		if(nModel == nCurModel){nCurIndex = nIndex;}
	}

	// select current model name
//	pCurHmm = pHmmLook->GetCurModel();
//	s = pCurHmm->GetName();
//	nIndex = pCBox->FindStringExact(0, s);//;
	for(nIndex = 0; nIndex < pCBox->GetCount(); nIndex++){
		nModel = pCBox->GetItemData(nIndex);
		if(nModel == nCurModel){
			pCBox->SetCurSel(nIndex);
			break;
		}
	}
	OnSelChangePhone();

}
void CMainFrame::OnSelChangePhone()
{
	CString strText;
	CString strItem;
	CComboBox* pCBox = (CComboBox*)m_wndDlgBar.GetDlgItem(IDC_PHONE);
	int nIndex = pCBox->GetCurSel();
	if (nIndex == CB_ERR)
		return;
	pCBox->GetLBText(nIndex, strItem);
//	AfxFormatString1(strText, IDS_SELECTED_PROMPT, (LPCTSTR)strItem);
	strText.Format(_T("Selected: %s"), strItem);
	SetMessageText(strText);

	// change view
	int nModel = pCBox->GetItemData(nIndex);
	CDocument* pDoc = m_pQlView->GetDocument(); //GetActiveDocument();
	if(!pDoc || ! pDoc->IsKindOf(RUNTIME_CLASS(CQlookDoc)) ){
		return;
	}
	((CQlookView*)m_pQlView)->SetCurModel(nModel);
	m_pQlView->Invalidate();
	((CQlookView*)m_pQlView)->SetRefreshView();
	return;

	CQlookDoc* pQlDoc = (CQlookDoc*)pDoc;
	CHMMLook* pHmmLook = pQlDoc->GetHMMLook();
	pHmmLook->SetCurModelIdx(nModel);
	pDoc->UpdateAllViews(0);
	CView *pView = GetActiveView();
	if(pView){pView->Invalidate();}
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

