// MemPaint.h: interface for the CMemPainter class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_MEMPAINT_H__D9516186_2F73_4649_9644_5764103FF6BE__INCLUDED_)
#define AFX_MEMPAINT_H__D9516186_2F73_4649_9644_5764103FF6BE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//
#include "..\SharAnim\animate.h"

class CMemPainter  
{
public:
	CMemPainter();
	virtual ~CMemPainter();

	CDIBSurface* m_pdibs; // pointer to DIB surface object 
	BYTE* m_pCurLine;
	int m_nCurX;
	int m_nOriginX;
	int m_nOriginY;

	BYTE m_brc; BYTE m_bgc; BYTE m_bbc; // counts of rgb bits
	BYTE m_brs; BYTE m_bgs; BYTE m_bbs; // shifts of rgb bits
	int m_nPixByteLen;

	int AssignDIBSurface(CDIBSurface* pdibs){
		m_pdibs = pdibs;
		if(!pdibs){return -1;}
		m_pdibs->GetRGBABitCount(&m_brc, &m_bgc, &m_bbc);
		m_pdibs->GetRGBABitShift(&m_brs, &m_bgs, &m_bbs);
		m_nPixByteLen = m_pdibs->GetBitsPerPixel() / 8;
		VERIFY(m_pCurLine=(BYTE*)m_pdibs->GetBitsAddress());
		m_nCurX=0;
		m_nOriginX=0;
		m_nOriginY=0;

		return 0;
	};
	// TODO:
//	inline void RGB2Pixel(BYTE* pbPix, BYTE br, BYTE bg, BYTE bb);

	inline DWORD PackPixel(BYTE br, BYTE bg, BYTE bb) // pixel Packed to DWORD ?
	{
		return ((BYTE)(br>>(8-m_brc))<<m_brs) |
			((BYTE)(bg>>(8-m_bgc))<<m_bgs) |
			((BYTE)(bb>>(8-m_bbc))<<m_bbs);
	};
	inline void SetLinePixel(BYTE* pbLine, int nPos, BYTE br, BYTE bg, BYTE bb) // pixel Packed to DWORD ?
	{
		DWORD dwRGB = PackPixel(br,bg,bb);
		pbLine += m_nPixByteLen * nPos;
		for(int i=0; i<m_nPixByteLen; i++){
			pbLine[i] = ((BYTE*)(&dwRGB))[i];
		}
	};
	inline void SetLinePixel(BYTE* pbLine, int nPos, DWORD dwRGB) // pixel Packed to DWORD ?
	{
		pbLine += m_nPixByteLen * nPos;
		for(int i=0; i<m_nPixByteLen; i++){
			pbLine[i] = ((BYTE*)(&dwRGB))[i];
		}
	};

};

#endif // !defined(AFX_MEMPAINT_H__D9516186_2F73_4649_9644_5764103FF6BE__INCLUDED_)
