// qlookView.cpp : implementation of the CQlookView class
//

#include "stdafx.h"
#include "qlook.h"

#include "HMMLook.h"
#include "qlookDoc.h"
#include "ScrlVwX.h"
#include "MemPaint.h"
#include "qlookView.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CQlookView

IMPLEMENT_DYNCREATE(CQlookView, CScrollViewEnh)

BEGIN_MESSAGE_MAP(CQlookView, CScrollViewEnh)
	//{{AFX_MSG_MAP(CQlookView)
	ON_WM_DESTROY()
	ON_COMMAND(ID_EDIT_INVERTCOLORS, OnEditInvertcolors)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollViewEnh::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollViewEnh::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollViewEnh::OnFilePrintPreview)
	ON_COMMAND(ID_VIEW_ZOOMIN, &CQlookView::OnViewZoomin)
	ON_COMMAND(ID_VIEW_ZOOMNORMAL, &CQlookView::OnViewZoomnormal)
	ON_COMMAND(ID_VIEW_ZOOMOUT, &CQlookView::OnViewZoomout)
	ON_COMMAND(ID_VIEW_SHOWMEANS, &CQlookView::OnViewShowmeans)
	ON_UPDATE_COMMAND_UI(ID_VIEW_SMALLICON, &CQlookView::OnUpdateViewShowmeans)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQlookView construction/destruction

CQlookView::CQlookView()
{
	// TODO: add construction code here
	m_nChanRep = 30; //10;
	m_nBasicChannels = 13;
	m_nEqualValueRegions = 3;
	m_nCurModel = 0;
	m_dwZeroValueRGB = RGB(0x0ff,0,0);
	m_dwMeanValueRGB = RGB(0x0,0x0aa,0);
	m_dwFontColorRGB = RGB(0x0ff,0x0ff,0x0ff);
	m_clrBackground = 0;
	m_bInvertColors = false;
	m_bShowMeans = true;

}

CQlookView::~CQlookView()
{
}

BOOL CQlookView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollViewEnh::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CQlookView drawing

void CQlookView::OnDraw(CDC* pDC)
{
	CQlookDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
//	CScrollViewEnh::OnDraw(pDC);
	// fill update rect with background
	{
		CBrush br; //(m_clrBackground);
		br.CreateSolidBrush(m_clrBackground);
		pDC->FillRect(&m_rectUpdate, &br);
		// Flush the GDI queue before doing any direct pixel ops.
		GdiFlush();
	}
	pDC->SetBkMode(TRANSPARENT);
	DrawImage(pDC);
	// TODO: add draw code for native data here
}


// These and more drawing functions are now in CMemPainter and here are OBSOLETE
DWORD CQlookView::PackPixel(BYTE br, BYTE bg, BYTE bb) // pixel Packed to DWORD ?
{
	return ((BYTE)(br>>(8-m_brc))<<m_brs) |
		((BYTE)(bg>>(8-m_bgc))<<m_bgs) |
		((BYTE)(bb>>(8-m_bbc))<<m_bbs);
}
void CQlookView::SetLinePixel(BYTE* pbLine, int nPos, BYTE br, BYTE bg, BYTE bb) // pixel Packed to DWORD ?
{
	DWORD dwRGB = PackPixel(br,bg,bb);
	pbLine += m_nPixByteLen * nPos;
	for(int i=0; i<m_nPixByteLen; i++){
		pbLine[i] = ((BYTE*)(&dwRGB))[i];
	}
}
void CQlookView::SetLinePixel(BYTE* pbLine, int nPos, DWORD dwRGB) // pixel Packed to DWORD ?
{
	pbLine += m_nPixByteLen * nPos;
	for(int i=0; i<m_nPixByteLen; i++){
		pbLine[i] = ((BYTE*)(&dwRGB))[i];
	}
}

void CQlookView::DrawImage(CDC* pDC)
{
	// now test the possibility to draw images
	if(!m_pdibs /*|| !m_bShowSpectre*/){return;}// dib surface [3VI2k1]
//	if(!m_pSpectres1stVisible || !m_pSpectresTail){// spectres
//		return;	}
//	BYTE brc, bgc, bbc; // counts of rgb bits
//	BYTE brs, bgs, bbs; // shifts of rgb bits
	m_pdibs->GetRGBABitCount(&m_brc, &m_bgc, &m_bbc);
	m_pdibs->GetRGBABitShift(&m_brs, &m_bgs, &m_bbs);
	m_nPixByteLen = m_pdibs->GetBitsPerPixel() / 8;
	BYTE* pb;

//	::GdiFlush();
	VERIFY(pb=(BYTE*)m_pdibs->GetBitsAddress());
	int i, j, n, nWidth;
	BYTE br=0;//0x0fe;
	BYTE bg=0;//0;
	BYTE bb=0;//0;
	BYTE* pbLine;
	WORD wPix;
	DWORD dwPix;
	DWORD dwBkg=::GetSysColor(COLOR_WINDOW);
	WORD wBkg=((BYTE)(GetRValue(dwBkg)>>(8-m_brc))<<m_brs) |
		((BYTE)(GetGValue(dwBkg)>>(8-m_bgc))<<m_bgs) |
		((BYTE)(GetBValue(dwBkg)>>(8-m_bbc))<<m_bbs);

	CQlookDoc* pDoc = GetDocument();
	CHMMLook* pHLook = pDoc->GetHMMLook();
	int nState = 0;
	int nChannels = pHLook->GetChannels();
	int nValues = 0;
	float* pValues;
	int nValueRegion; // c, dc, ddc
	pHLook->SetCurModelIdx(m_nCurModel);
	CHMMModel* pModel = pHLook->GetCurModel();
	int nStartChan=0, nRegionChannels=nChannels / m_nEqualValueRegions;
	int nMargin = 5;
	CString s = _T("0000000");
	CSize sizeScale = pDC->GetTextExtent(s);
	CSize size;
	pDC->SetTextColor(m_dwFontColorRGB);
	pDC->SetBkColor(~m_dwFontColorRGB);
	m_ProbView.m_bInvertColors = m_bInvertColors;
	m_ProbView.m_bShowMeans = m_bShowMeans;

	for(nValueRegion=0; nValueRegion < m_nEqualValueRegions; nValueRegion++){
		nStartChan = nValueRegion * nRegionChannels;
		m_ProbView.m_nOriginY = (int)(nMargin * 3.5) + nValueRegion * (nValues + nMargin);
		for(nState = 0; nState < pModel->GetStateCount(); nState++){
			VERIFY(pValues = pHLook->GetProbValues(nState, nValues));
			if(!pValues){return;}
			pValues += nStartChan * nValues;
			m_ProbView.AssignDIBSurface(m_pdibs);
			m_ProbView.m_nChanRep = m_nChanRep; // columns width
			// set object position
			m_ProbView.m_nOriginX = sizeScale.cx + nState * (
				nRegionChannels * m_nChanRep + nMargin * 2); // by state
			m_ProbView.m_nOriginY = (int)(nMargin * 3.5) + nValueRegion * (nValues + nMargin);
			m_ProbView.m_nBorderWidth = nMargin * 2;
			m_ProbView.PrepareImage(pValues, nRegionChannels, nValues, 
				pHLook, nState, nStartChan);
			m_ProbView.MapImageToBmpSurface();
		}// NEXT state

		// draw scale numbers
		{
			CFont* pfOld=pDC->GetCurrentFont(); //m_csAppTitle.GetFont();
			CFont fScale;
			LOGFONT lf;
			if(pfOld){// decrease font size
				pfOld->GetLogFont(&lf);
				if(lf.lfHeight<0){lf.lfHeight+=3;}
				else{lf.lfHeight-=3;}
				fScale.CreateFontIndirect(&lf);
				pfOld = pDC->SelectObject(&fScale);
			}
			CBrush* pbrOld = pDC->GetCurrentBrush();

			float min, max, min2, max2;
			int x,y;
			pHLook->GetChannelMinMax(nStartChan, min, max);
			s.Format("%.2f", max);
			size = pDC->GetTextExtent(s);
			y = m_ProbView.m_nOriginY;
			x = sizeScale.cx - size.cx - 1;
			pDC->TextOut(x, y, s);
			s.Format("%.2f", min);
			size = pDC->GetTextExtent(s);
			x = sizeScale.cx - size.cx - 1;
			y = m_ProbView.m_nOriginY + nValues - size.cy;
			pDC->TextOut(x, y, s);
			// print alternative min/max, if present
			pHLook->GetChannelMinMax(nStartChan + nRegionChannels - 1, min2, max2);
			if(min != min2 || max != max2){
				s.Format("(%.2f)", max2);
				size = pDC->GetTextExtent(s);
				y = m_ProbView.m_nOriginY + (size.cy);
				x = sizeScale.cx - size.cx - 1;
				pDC->TextOut(x, y, s);
				s.Format("(%.2f)", min2);
				size = pDC->GetTextExtent(s);
				x = sizeScale.cx - size.cx - 1;
				y = m_ProbView.m_nOriginY + nValues - (size.cy*2 + 2);
				pDC->TextOut(x, y, s);
			}
			if(pfOld){
				pDC->SelectObject(&pfOld);
			}
		}
		// TODO:
	}// NEXT value region

	// display model name
	{
		s = pModel->GetName();
		CString ss;
		ss.Format(_T("   %s (%d mixes)    "), s, pModel->m_States[0].m_Mixes.GetSize());
		pDC->TextOut(0, 0, ss);
	}

	return;
	pb=pb;
	for(i=0, pbLine=pb; i<m_pdibs->GetHeight()/2/*bmp.bmHeight*/; i++)
	{// lines
		nWidth = m_pdibs->GetStorageWidth()/m_nPixByteLen;
		for(j=0; j<nWidth; j++){
			SetLinePixel(pbLine, j, br,bg,bb);
			 br=bg=++bb;
		}

		pbLine += m_pdibs->GetStorageWidth();//bmp.bmWidthBytes;
	}
}

void CQlookView::OnInitialUpdate()
{
	CScrollViewEnh::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CQlookView printing

BOOL CQlookView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CQlookView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CQlookView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CQlookView diagnostics

#ifdef _DEBUG
void CQlookView::AssertValid() const
{
	CScrollViewEnh::AssertValid();
}

void CQlookView::Dump(CDumpContext& dc) const
{
	CScrollViewEnh::Dump(dc);
}

CQlookDoc* CQlookView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CQlookDoc)));
	return (CQlookDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CQlookView message handlers


void CQlookView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	pFrame->FillPhoneList(bActivate ? this : 0);

	CScrollViewEnh::OnActivateView(bActivate, pActivateView, pDeactiveView);
}

void CQlookView::OnDestroy() 
{
	CScrollViewEnh::OnDestroy();
	
//	CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
//	pFrame->FillPhoneList(0);
	// TODO: Add your message handler code here
	
}
DWORD InvertRGBA(DWORD& rgba){
//	(*(WORD*)&rgba) ~= (*(WORD*)&rgba);
//	(*(((WORD*)&rgba) +2)) = 0;
/*	register DWORD ret;
	rgba = ~rgba;
	(*(((BYTE*) &rgba) + 3)) = ~(*(((BYTE*) &rgba) + 3));
	return rgba;*/
	DWORD ret = (rgba & 0x0ff000000);
	ret |= (~rgba) & 0x0ffffff;
	return ret;
	return (rgba & 0x0ff000000) | ((~rgba) & 0x0ffffff);
}
void CQlookView::OnEditInvertcolors() 
{
	m_bInvertColors = !m_bInvertColors;
	m_dwZeroValueRGB = InvertRGBA(m_dwZeroValueRGB);
	m_dwMeanValueRGB = InvertRGBA(m_dwMeanValueRGB);
	m_dwFontColorRGB = InvertRGBA(m_dwFontColorRGB);
	m_clrBackground = InvertRGBA(m_clrBackground);
	m_bNeedRedrawProc = true;
	Invalidate();
	GetDocument()->UpdateAllViews(0);
}


//{{{
/////////////// --- CHmmProbPainter
CHmmProbPainter::CHmmProbPainter():CMemPainter()
{
	m_nChannels=0;
	m_nValues=0;
	m_ScaleMapper = 1000; //255 * 2;
	m_nChanRep = 16; //10;
	m_nBorderWidth = m_nChanRep;
	m_dwBorderRGB = 0x0ccaa00;//0x0ffff00;
	m_dwIncBorderRGB = 0x0180f00;
	m_bInvertColors = false;
	m_bShowMeans = true;
	m_clrZeros = RGB(0x0, 0x0, 0x0);
	m_clrMeans = RGB(0x00, 0x00, 0x0f0);
}

void GetMinMax(float* probs, int nChannels, float& min, float& max){
	if(!probs){return;}
	int i;
	float value;
	min = 1000000, max = -min;
	for(i=0; i<nChannels; i++){
		value = probs[i];
		if(value > max){
			max = value;
		}
		if(value < min){
			min = value;
		}
	}
	return;
}
int CHmmProbPainter::PrepareImage(float* probs, int nChannels, int nValues, 
								  CHMMLook* pHLook, int nState, int nStartChannel)
{
	if(!probs || nChannels<1 || nValues<1){return -1;}
	int nChan, nMix, nMixIdx, j, nGrade, 
		MeanDistance, MeanRunning, MeanColor;
	float min, max;
	int nZeroIdx = -1;
	int PixelIsSet = 0;
	BYTE *pb, *pb2, *pb3, *pb4;
	m_nValues = nValues;
	m_nChannels = nChannels;
	m_arrPixels.SetSize(nChannels * nValues);
	m_arrPixels2.SetSize(nChannels * nValues);
	m_arrPixels3.SetSize(nChannels * nValues);
	m_arrPixels4.SetSize(nChannels * nValues);

	// [min; max] => [0, 255] <=> 
	// a + b*min = 0; a + b*max = 255; <=> b = 255/(max - min); a = -b*min;
	GetMinMax(probs, nChannels * nValues, min, max);
	float scale_a, scale_b;
	scale_b = 255. / (float)(max - min);
	scale_a = -scale_b * min;

	for(nChan=0; nChan<nChannels; nChan++){
		if(pHLook && nState>=0 && nStartChannel>=0){// get zero and mean idxs
			nZeroIdx = pHLook->GetChannelZeroIdx(nState, nStartChannel+nChan);
			m_arrCurChanMeanIdxs.SetSize(0);
			for(nMix=0; (nMixIdx = pHLook->GetMeanIdx(
				nState, nStartChannel+nChan, nMix)) >= 0; nMix++)
			{// sort means for each mix
				for(j=0; j<m_arrCurChanMeanIdxs.GetSize(); j++){
					if(m_arrCurChanMeanIdxs[j] > nMixIdx){
						break;
					}
				}
				m_arrCurChanMeanIdxs.InsertAt(j, nMixIdx);
			}
		}// end zeros and means accepting
		nMix = 0; MeanDistance = nValues;
		for(j = MeanRunning = 0; j<nValues; j++, MeanDistance++) // for(j=nValues-1; j>=0; j--) //
		{
			PixelIsSet = 0;
			pb = (BYTE*)(m_arrPixels.GetData() + (nValues*nChan + j));
			pb2 = (BYTE*)(m_arrPixels2.GetData() + (nValues*nChan + j));
			pb3 = (BYTE*)(m_arrPixels4.GetData() + (nValues*nChan + j));
			pb4 = (BYTE*)(m_arrPixels3.GetData() + (nValues*nChan + j));
			if(nMix >= 0 && j == m_arrCurChanMeanIdxs[nMix]){
//?				*((DWORD*) pb) = m_bInvertColors ? /*~m_clrMeans*/0x0 : m_clrMeans;
//?				*((DWORD*) pb2) = m_bInvertColors ? /*~m_clrMeans*/0x0 : m_clrMeans;
				while(++nMix < m_arrCurChanMeanIdxs.GetSize()){
					if(m_arrCurChanMeanIdxs[nMix-1] != m_arrCurChanMeanIdxs[nMix]){
						break;
					}
				}
				if(nMix >= m_arrCurChanMeanIdxs.GetSize()){nMix = -1;}
				if((j == nZeroIdx) //&& (j % 2)
					){
//					*((DWORD*) pb) = m_bInvertColors ? ~m_clrZeros : m_clrZeros;
				}
				if(MeanDistance <= 1){
					MeanRunning++;
				}else{
					MeanRunning = 0;
				}
				PixelIsSet = 1;
			}
			if(j == nZeroIdx){// zero value
				if(!PixelIsSet){ // we are beyond means
					*((DWORD*) pb) = m_bInvertColors ? ~m_clrZeros : m_clrZeros;
					*((DWORD*) pb3) = m_bInvertColors ? ~m_clrZeros : m_clrZeros;
				}
				if(PixelIsSet){ // we are in the mean
					*((DWORD*) pb2) = m_bInvertColors ? ~m_clrZeros : m_clrZeros;
					*((DWORD*) pb4) = m_bInvertColors ? ~m_clrZeros : m_clrZeros;
				}
				PixelIsSet |= 2;
			}
//			if(!PixelIsSet)
			while(true)
			{
				nGrade = (int)(scale_a + probs[nValues*nChan + j] * scale_b);
				if(m_clrZeros){ // ?
					nGrade = ~((BYTE)nGrade);
				} 
				if(nGrade > 20){
					MeanColor = (nGrade - 10) / 4;
				}else{
					MeanColor = (nGrade + 5) * 3;
				}
				MeanColor += (MeanRunning % 2) * 32;
				// = (int)(probs[nValues*nChan + j] * m_ScaleMapper);
				if(nGrade > 255){
					nGrade = 255;
				}if(nGrade < 0){
					//				ASSERT(false);
					nGrade = 0;
				}
				if((PixelIsSet & 2) == 0) // if not in zero pixel
				{// mask basic pixel with grade color
					pb3[0] = pb3[1] = pb3[2] = nGrade;
					pb4[0] = pb4[1] = pb4[2] = nGrade;
					if((PixelIsSet & 1)){ // not zero but mean
						if(m_bShowMeans){
							pb[0] = pb[1] = pb[2] = MeanColor; // point a mean pixel
							pb2[0] = pb2[1] = pb2[2] = MeanColor; // NOT altering with grade color
						}else{
							pb[0] = nGrade;pb[1] = nGrade;pb[2] = nGrade;
							pb2[0] = pb2[1] = pb2[2] = nGrade;
						}
					}else{
						pb[0] = nGrade;pb[1] = nGrade;pb[2] = nGrade;
					}
				}
				if((PixelIsSet & 1) == 0)
				{ // we are beyond means: mask alternative pixel with grade color 
					pb2[0] = nGrade;pb2[1] = nGrade;pb2[2] = nGrade;
					if((PixelIsSet & 2)) {// if in zero pixel
						pb4[0] = pb4[1] = pb4[2] = nGrade;
					}
				}else if(PixelIsSet == 3){ // in both the mean and zero
					pb3[0] = pb3[1] = pb3[2] = nGrade;
					if(m_bShowMeans){
						pb[0] = pb[1] = pb[2] = MeanColor; // point a mean pixel
					}else{
						pb[0] = pb[1] = pb[2] = nGrade; // do not show means
					}
//					pb2[0] = pb2[1] = pb2[2] = nGrade; // altering with grade color
				}
				break;
			}
			if((PixelIsSet & 1)){// we were in the mean
				MeanDistance = 0;
			}
		} // NEXT value
	}
	return 0;
}

int CHmmProbPainter::MapImageToBmpSurface()
{
	int nChan, i, j, k, LeftSideWidth;
	BYTE* pbStartLine = (BYTE*)m_pdibs->GetBitsAddress();
	BYTE* pbLine = pbStartLine;
	int nStartPos = m_nOriginX;
	int nPos;
	int nWidth = m_pdibs->GetStorageWidth();
	int nHeight = m_pdibs->GetHeight();
//	pbStartLine += nWidth * m_nOriginY;
	for( nChan=0; nChan<m_nChannels; nChan++ ){
		nPos = nStartPos + nChan * m_nChanRep;
		if(nPos >= nWidth / m_nPixByteLen){break;}
//		for(j=m_nValues-1; j>=0; j--)
		j = -(nHeight - 1 - m_nOriginY - (m_nValues-1));
		if(j < 0){j = 0;}
		for(j=0; j<m_nValues; j++)
		{
			if(j > nHeight + m_nOriginY){
//				break;
			}
///			pbLine = pbStartLine + (nHeight - 1 - j - m_nOriginY) * nWidth; // !!!
			if((nHeight - 1 - m_nOriginY - (m_nValues-1) + j) < 0){
				continue;}
			pbLine = pbStartLine + (nHeight - 1 - m_nOriginY - (m_nValues-1) + j) * nWidth; // !!!
			if(pbLine - pbStartLine >= nWidth * nHeight){
				continue;} // ?!!
			register DWORD dwRGBA, dwRGBA2, dwRGBA3, dwRGBA4;
			dwRGBA = m_arrPixels[m_nValues*nChan + j];
			dwRGBA2 = m_arrPixels2[m_nValues*nChan + j];
			dwRGBA3 = m_arrPixels3[m_nValues*nChan + j];
			dwRGBA4 = m_arrPixels4[m_nValues*nChan + j];
			if(m_bInvertColors){dwRGBA = ~dwRGBA;}
			if(m_bInvertColors){dwRGBA2 = ~dwRGBA2;}
			if(m_bInvertColors){dwRGBA3 = ~dwRGBA3;}
			if(m_bInvertColors){dwRGBA4 = ~dwRGBA4;}
//			dwRGBA = 0x0ffffffff;
			LeftSideWidth = m_nChanRep / 4;
			if(LeftSideWidth < 2){LeftSideWidth = 2;}
			if(LeftSideWidth >= m_nChanRep){LeftSideWidth = m_nChanRep / 2;}
			for(k=0; k<LeftSideWidth; k++){
				if(m_nPixByteLen == 4){
			
					*( (DWORD*)(pbLine + (nPos + k) * m_nPixByteLen) ) = 
						(k % 2) ? dwRGBA : dwRGBA2;
				}else{// other than 32 bytes pixel
					register BYTE* pb = (BYTE*)& ((k % 2) ? dwRGBA : dwRGBA2);
					SetLinePixel(pbLine + (nPos + k) * m_nPixByteLen, 0, pb[0], pb[1], pb[2]);
				}
			}// NEXT repeating
			for( ; k<m_nChanRep; k++){
				if(m_nPixByteLen == 4){
					
					*( (DWORD*)(pbLine + (nPos + k) * m_nPixByteLen) ) = 
						(k % 2) ? dwRGBA3 : dwRGBA4;
				}else{// other than 32 bytes pixel
					register BYTE* pb = (BYTE*)& ((k % 2) ? dwRGBA3 : dwRGBA4);
					SetLinePixel(pbLine + (nPos + k) * m_nPixByteLen, 0, pb[0], pb[1], pb[2]);
				}
			}// NEXT repeating
		}// NEXT value
		// draw bottom border
		{
			pbLine = pbStartLine + (nHeight - 1 - j - m_nOriginY) * nWidth;
//			pbLine = pbStartLine + (nHeight - 1 - m_nOriginY - (m_nValues-1)) * nWidth; // !!!
			if((nHeight - 1 - j - m_nOriginY) < 0){
				continue;}
			register DWORD dwRGBA = m_dwBorderRGB;
			for(k=0; k<m_nChanRep; k++){
				if(m_nPixByteLen == 4){
					*( (DWORD*)(pbLine + (nPos + k) * m_nPixByteLen) ) = dwRGBA;
				}else{// other than 32 bytes pixel
					register BYTE* pb = (BYTE*)&dwRGBA;
					SetLinePixel(pbLine + (nPos + k) * m_nPixByteLen, 0, pb[0], pb[1], pb[2]);
				}
			}// NEXT repeating
		}
	}// NEXT channel

	// TODO: right border
	nPos = nStartPos + m_nChannels * m_nChanRep;
	for(j=0; j<m_nValues; j++){
		if(j>nHeight + m_nOriginY){break;}
		if((nHeight - 1 - j - m_nOriginY) < 0){continue;}
		pbLine = pbStartLine + (nHeight - 1 - j - m_nOriginY) * nWidth;
		register DWORD dwRGBA;// = m_arrPixels[m_nValues*nChan + j];
		dwRGBA = 0;//m_dwBorderRGB;
		for(k=0; k<m_nBorderWidth; k++){
			dwRGBA += m_dwIncBorderRGB;//-= 0x01f0f00; // grade
//			if(dwRGBA & 0x080000000){dwRGBA = 0x00;}
			if(m_nPixByteLen == 4){
				*( (DWORD*)(pbLine + (nPos + k) * m_nPixByteLen) ) = 
					m_bInvertColors ? ~dwRGBA : dwRGBA;
			}else{// other than 32 bytes pixel
				register BYTE* pb = (BYTE*)&dwRGBA;
				SetLinePixel(pbLine + (nPos + k) * m_nPixByteLen, 0, pb[0], pb[1], pb[2]);
			}
		}// NEXT repeating
	}// NEXT value
	return 0;
}

//}}}



void CQlookView::OnViewZoomin()
{
	// TODO: Add your command handler code here
	ChangeZoom(1.05);
}

void CQlookView::OnViewZoomnormal()
{
	// TODO: Add your command handler code here
	ChangeZoom(0);
}

void CQlookView::OnViewZoomout()
{
	// TODO: Add your command handler code here
	ChangeZoom(.95);
}

void CQlookView::ChangeZoom(float NewZoom)
{
	CQlookDoc* pDoc = GetDocument();
	CHMMLook* pHLook = pDoc->GetHMMLook();
	int nValues = 0;

	pHLook->GetProbValues(0, nValues);
	if(!NewZoom){nValues = 256; // set zoom to normal
	}else{
		nValues = (int)(nValues * NewZoom);
	}
	if(!pHLook->SetTestedValuesCount(nValues)){return;}

	pHLook->AnalyseModel();

	m_bNeedRedrawProc = true;
	Invalidate();
	GetDocument()->UpdateAllViews(0);
}


void CQlookView::OnViewShowmeans()
{
	m_bShowMeans = !m_bShowMeans;
	m_bNeedRedrawProc = true;
	Invalidate();
	GetDocument()->UpdateAllViews(0);
}

void CQlookView::OnUpdateViewShowmeans(CCmdUI *pCmdUI)
{
	pCmdUI->SetCheck(m_bShowMeans);
	pCmdUI->Enable();
}
