// qlookView.h : interface of the CQlookView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_QLOOKVIEW_H__90E3056C_B288_4E1E_986E_CFE3314517A1__INCLUDED_)
#define AFX_QLOOKVIEW_H__90E3056C_B288_4E1E_986E_CFE3314517A1__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CHmmProbPainter : public CMemPainter
{
public:
	CHmmProbPainter();
	~CHmmProbPainter(){};

	int PrepareImage(float* probs, int nChannels, int nValues, 
		CHMMLook* pHLook=0, int nState=-1 , int nStartChannel=-1);
	int SetHorRepeat(int nrep){ASSERT(nrep>0); m_nChanRep = nrep; return nrep;};
	int MapImageToBmpSurface();
	void SetBorderWidth(int nWidth){m_nBorderWidth = nWidth;};


	CDWordArray m_arrPixels;
	CDWordArray m_arrPixels2;
	CDWordArray m_arrPixels3;
	CDWordArray m_arrPixels4;
	int m_nStartChannel;
	int m_nChannels;
	int m_nValues;
	float m_ScaleMapper;
	int m_nChanRep;
	int m_nBorderWidth;
	DWORD m_dwBorderRGB;
	DWORD m_dwIncBorderRGB;
	bool m_bInvertColors;
	bool m_bShowMeans;

	COLORREF m_clrZeros;
	COLORREF m_clrMeans;
	CWordArray m_arrCurChanMeanIdxs;
};

class CQlookView : public CScrollViewEnh
{
protected: // create from serialization only
	CQlookView();
	DECLARE_DYNCREATE(CQlookView)

// Attributes
public:
	CQlookDoc* GetDocument();
	int SetCurModel(int nModel){m_nCurModel = nModel; return nModel;};
	int GetCurModel(){return m_nCurModel;};

	int m_nChanRep;
	int m_nBasicChannels;
	int m_nEqualValueRegions;
	int m_nCurModel;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CQlookView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CQlookView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	void DrawImage(CDC* pDC);
	void ChangeZoom(float NewZoom);

	CHmmProbPainter m_ProbView;

	DWORD m_dwZeroValueRGB;
	DWORD m_dwMeanValueRGB;
	DWORD m_dwFontColorRGB;
	DWORD m_clrBackground;
	bool m_bInvertColors;
	bool m_bShowMeans;

	// These and more drawing functions are now in CMemPainter and here are OBSOLETE
	inline void SetLinePixel(BYTE* pbLine, int nPos, BYTE br, BYTE bg, BYTE bb);
	inline void SetLinePixel(BYTE* pbLine, int nPos, DWORD dwRGB); // pixel Packed to DWORD ?
	inline DWORD PackPixel(BYTE br, BYTE bg, BYTE bb); // pixel Packed to DWORD ?

	// OBSOLETE as well
	BYTE m_brc; BYTE m_bgc; BYTE m_bbc; // counts of rgb bits
	BYTE m_brs; BYTE m_bgs; BYTE m_bbs; // shifts of rgb bits
	int m_nPixByteLen;

// Generated message map functions
protected:
	//{{AFX_MSG(CQlookView)
	afx_msg void OnDestroy();
	afx_msg void OnEditInvertcolors();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnViewZoomin();
	afx_msg void OnViewZoomnormal();
	afx_msg void OnViewZoomout();
	afx_msg void OnViewShowmeans();
	afx_msg void OnUpdateViewShowmeans(CCmdUI *pCmdUI);
};

#ifndef _DEBUG  // debug version in qlookView.cpp
inline CQlookDoc* CQlookView::GetDocument()
   { return (CQlookDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_QLOOKVIEW_H__90E3056C_B288_4E1E_986E_CFE3314517A1__INCLUDED_)
